import classNames from 'classnames';
import React from 'react';
import { withNativeProps } from '../../utils/native-props';
const classPrefix = `adm-badge`;
export const dot = Symbol();
export const Badge = props => {
  const {
    content,
    color,
    children
  } = props;
  const isDot = content === dot;
  const badgeCls = classNames(classPrefix, {
    [`${classPrefix}-fixed`]: !!children,
    [`${classPrefix}-dot`]: isDot
  });
  const element = content ? withNativeProps(props, React.createElement("div", {
    className: badgeCls,
    style: {
      '--color': color
    }
  }, !isDot && content)) : null;
  return children ? React.createElement("div", {
    className: `${classPrefix}-wrap`
  }, children, element) : element;
};