"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PopMenu = void 0;

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _button = _interopRequireDefault(require("../button"));

var _popover = require("./popover");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const classPrefix = `adm-popover`;
const PopMenu = (0, _react.forwardRef)((props, ref) => {
  const innerRef = (0, _react.useRef)(null);
  (0, _react.useImperativeHandle)(ref, () => innerRef.current, []);
  const onClick = (0, _react.useCallback)(e => {
    var _a;

    const {
      onAction
    } = props;

    if (onAction) {
      onAction(e);
    }

    (_a = innerRef.current) === null || _a === void 0 ? void 0 : _a.hide();
  }, [props.onAction]);
  const overlay = (0, _react.useMemo)(() => {
    return _react.default.createElement(_react.default.Fragment, null, (props.actions || []).map((ele, index) => {
      var _a;

      return _react.default.createElement("div", {
        className: (0, _classnames.default)(`${classPrefix}-inner-menu`, {
          [`${classPrefix}-inner-menu-with-icon`]: !!ele.icon
        }),
        key: (_a = ele.key) !== null && _a !== void 0 ? _a : index
      }, _react.default.createElement(_button.default, {
        disabled: ele.disabled,
        onClick: () => {
          var _a;

          if (!ele.disabled) {
            onClick(ele);
            (_a = ele.onClick) === null || _a === void 0 ? void 0 : _a.call(ele);
          }
        },
        fill: 'none',
        block: true
      }, ele.icon && _react.default.createElement("span", {
        className: `${classPrefix}-inner-menu-icon`
      }, ele.icon), ele.text));
    }));
  }, [props.actions, onClick]);
  return _react.default.createElement(_popover.Popover, Object.assign({
    ref: innerRef
  }, props, {
    overlayClassName: (0, _classnames.default)(`${classPrefix}-menu`, props.overlayClassName),
    content: overlay
  }), props.children);
});
exports.PopMenu = PopMenu;