import React, { forwardRef, useCallback, useImperativeHandle, useMemo, useRef } from 'react';
import classNames from 'classnames';
import Button from '../button';
import { Popover } from './popover';
const classPrefix = `adm-popover`;
export const PopMenu = forwardRef((props, ref) => {
  const innerRef = useRef(null);
  useImperativeHandle(ref, () => innerRef.current, []);
  const onClick = useCallback(e => {
    var _a;

    const {
      onAction
    } = props;

    if (onAction) {
      onAction(e);
    }

    (_a = innerRef.current) === null || _a === void 0 ? void 0 : _a.hide();
  }, [props.onAction]);
  const overlay = useMemo(() => {
    return React.createElement(React.Fragment, null, (props.actions || []).map((ele, index) => {
      var _a;

      return React.createElement("div", {
        className: classNames(`${classPrefix}-inner-menu`, {
          [`${classPrefix}-inner-menu-with-icon`]: !!ele.icon
        }),
        key: (_a = ele.key) !== null && _a !== void 0 ? _a : index
      }, React.createElement(Button, {
        disabled: ele.disabled,
        onClick: () => {
          var _a;

          if (!ele.disabled) {
            onClick(ele);
            (_a = ele.onClick) === null || _a === void 0 ? void 0 : _a.call(ele);
          }
        },
        fill: 'none',
        block: true
      }, ele.icon && React.createElement("span", {
        className: `${classPrefix}-inner-menu-icon`
      }, ele.icon), ele.text));
    }));
  }, [props.actions, onClick]);
  return React.createElement(Popover, Object.assign({
    ref: innerRef
  }, props, {
    overlayClassName: classNames(`${classPrefix}-menu`, props.overlayClassName),
    content: overlay
  }), props.children);
});