import React, { memo } from 'react';
import { withNativeProps } from '../../utils/native-props';
import { mergeProps } from '../../utils/with-default-props';
const classPrefix = 'adm-spin-loading';
const colorRecord = {
  default: 'var(--adm-color-weak)',
  primary: 'var(--adm-color-primary)',
  white: 'var(--adm-color-white)'
};
const defaultProps = {
  color: 'default'
};
export const SpinLoading = memo(p => {
  var _a;

  const props = mergeProps(defaultProps, p);
  return withNativeProps(props, React.createElement("div", {
    className: classPrefix,
    style: {
      '--color': (_a = colorRecord[props.color]) !== null && _a !== void 0 ? _a : props.color
    }
  }, React.createElement("svg", {
    className: `${classPrefix}-svg`
  }, React.createElement("circle", {
    className: `${classPrefix}-fill`,
    fill: 'transparent'
  }))));
});